local frame = CreateFrame("Frame")

frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("GARRISON_MISSION_FINISHED")
frame:RegisterEvent("GARRISON_MISSION_COMPLETE")
SetCVar("lastGarrisonMissionTutorial", 8);

function init(self, event, arg1, ...)
  
  if event == "ADDON_LOADED" and arg1 == "Blizzard_GarrisonUI" then
    
    Orig_Initialize = GarrisonMissionComplete_BeginAnims;
    GarrisonMissionComplete_BeginAnims = function(...)
      --[===[@debug@
      print("GarrisonMissionComplete_BeginAnims triggered!")
      --@end-debug@]===]
      local self = ...
      self.BonusRewards.ChestModel.OpenAnim:Stop();
      self.BonusRewards.ChestModel.LockBurstAnim:Stop();
      self.BonusRewards.ChestModel:SetAlpha(1);
      for i = 1, #self.BonusRewards.Rewards do
        self.BonusRewards.Rewards[i]:Hide();
      end
      self.BonusRewards.ChestModel.LockBurstAnim:Stop();
      self.ChanceFrame.SuccessAnim:Stop();
      self.ChanceFrame.FailureAnim:Stop();
      self.BonusRewards.Saturated:Show();
      self.BonusRewards.ChestModel.Lock:Hide();
      self.BonusRewards.ChestModel:SetAnimation(0, 0);
      self.BonusRewards.ChestModel.ClickFrame:Show();
      self.ChanceFrame.ChanceText:SetAlpha(0);
      self.ChanceFrame.FailureText:SetAlpha(0);
      self.ChanceFrame.SuccessText:SetAlpha(1);
      self.ChanceFrame.Banner:SetAlpha(1);
      self.ChanceFrame.Banner:SetWidth(GARRISON_MISSION_COMPLETE_BANNER_WIDTH);
      
      self.encounterIndex = 1;
      self.animIndex = animIndex or 0;
      self.animTimeLeft = 0;
      self:SetScript("OnUpdate", GarrisonMissionComplete_OnUpdate);
      self.NextMissionButton:Enable()
    end
    
    GARRISON_ANIMATION_LENGTH = 0;
    
    local Or_GarrisonMissionComplete_AnimLine = GarrisonMissionComplete_AnimLine;
    GarrisonMissionComplete_AnimLine = function(...)
      --[===[@debug@
      print("GarrisonMissionComplete_AnimLine triggered!")
      --@end-debug@]===]
      GarrisonMissionFrame.MissionComplete.NextMissionButton:Enable()
      GarrisonMissionComplete_PreloadEncounterModels(self);
      
      local iconWidth = 64;           -- size of portrait icon
      local iconEdgeSpace = 6;        -- empty space on either side of the portrait
      local lineAnimDuration = 0;  -- total time for line to animate from one end to another
      local modelWaitTime = 0;        -- extra time to wait for models to load
      
      local encounters = self.Stage.Encounters;
      local lineStart = encounters.EncounterBarFill:GetLeft();
      local lineEnd = encounters["Encounter"..self.encounterIndex]:GetLeft() + iconEdgeSpace;
      local duration = lineAnimDuration / #self.animInfo;
      entry.duration = duration;
      local barFill = encounters.EncounterBarFill;
      barFill.finalWidth = lineEnd - lineStart;
      barFill:SetWidth(barFill:GetWidth() + iconWidth - iconEdgeSpace * 2);
      local barSpark = encounters.EncounterBarSpark;
      barSpark.Anim.Translation:SetDuration(duration);
      barSpark.Anim.Translation:SetOffset(barFill.finalWidth - barFill:GetWidth(), 0);
      barSpark:Show();
      GarrisonMissionCompleteChest_OnMouseDown();
      GarrisonMissionFrame.MissionComplete.BonusRewards.ChestModel:Hide();
      GarrisonMissionComplete_ShowRewards();
    end
    
    local Or_GarrisonMissionCompleteChest_OnMouseDown = GarrisonMissionCompleteChest_OnMouseDown;
    GarrisonMissionCompleteChest_OnMouseDown = function(...)
      GarrisonMissionFrame.MissionComplete.NextMissionButton:Enable();
      --[===[@debug@
      print("GarrisonMissionCompleteChest_OnMouseDown triggered!")
      --@end-debug@]===]
      if ( C_Garrison.CanOpenMissionChest(GarrisonMissionFrame.MissionComplete.currentMission.missionID) ) then
        local bonusRewards = GarrisonMissionFrame.MissionComplete.BonusRewards;
        bonusRewards.waitForEvent = false;
        bonusRewards.waitForTimer = false;
        bonusRewards.success = false;
        bonusRewards:RegisterEvent("GARRISON_MISSION_BONUS_ROLL_COMPLETE");
        GarrisonMissionComplete_OnRewardTimer();
        C_Garrison.MissionBonusRoll(GarrisonMissionFrame.MissionComplete.currentMission.missionID);
        PlaySound("UI_Garrison_CommandTable_ChestUnlock_Gold_Success");
      end
    end   
  end
end

frame:SetScript("OnEvent", init)